SystemOrganization addCategory: #TusLibros!

Object subclass: #Book
	instanceVariableNames: 'name editorial'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TusLibros'!

!Book class methodsFor: 'as yet unclassified' stamp: 'FedericoMendez 5/27/2013 21:25'!
name: aName editorial: anEditorial 
	
	^ self new name: aName editorial: anEditorial ! !

!Book methodsFor: 'as yet unclassified' stamp: 'FedericoMendez 5/27/2013 21:29'!
editorial

	^ editorial! !

!Book methodsFor: 'as yet unclassified' stamp: 'FedericoMendez 5/27/2013 21:25'!
name: aName editorial: anEditorial 
	
	name := aName .
	editorial := anEditorial ! !

Object subclass: #Cart
	instanceVariableNames: 'booksInCart editorial'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TusLibros'!

!Cart class methodsFor: 'as yet unclassified' stamp: 'FedericoMendez 5/27/2013 21:27'!
editorial: anEditorial  
	
	^ self new editorial: anEditorial ! !

!Cart methodsFor: 'as yet unclassified' stamp: 'FedericoMendez 5/27/2013 21:39'!
add: aBook 
	
	(aBook editorial = editorial ) ifTrue: [ booksInCart add: aBook ]! !

!Cart methodsFor: 'as yet unclassified' stamp: 'FedericoMendez 5/27/2013 21:09'!
booksInCart
	
	^ booksInCart! !

!Cart methodsFor: 'as yet unclassified' stamp: 'FedericoMendez 5/27/2013 21:08'!
booksQuantity
	
	^ booksInCart size.! !

!Cart methodsFor: 'as yet unclassified' stamp: 'FedericoMendez 5/27/2013 21:28'!
editorial: anEditorial  
	
	editorial := anEditorial ! !

!Cart methodsFor: 'as yet unclassified' stamp: 'FedericoMendez 5/27/2013 21:48'!
initialize 

	booksInCart := Bag new.! !

!Cart methodsFor: 'as yet unclassified' stamp: 'FedericoMendez 5/27/2013 21:04'!
isEmpty
	
	^ booksInCart isEmpty ! !

TestCase subclass: #CartTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TusLibros'!

!CartTest methodsFor: 'as yet unclassified' stamp: 'FedericoMendez 5/27/2013 21:38'!
canNotAddABookFromOtherEditorialException

	^ 'CanNotAddABookToTheCart' ! !

!CartTest methodsFor: 'as yet unclassified' stamp: 'FedericoMendez 5/27/2013 21:27'!
test01CartShouldBeEmptyWhenCreated

	| cart |
	cart := Cart editorial: 'Tus Libros'.
	self assert: cart isEmpty! !

!CartTest methodsFor: 'as yet unclassified' stamp: 'FedericoMendez 5/27/2013 21:48'!
test02AddingABookShouldAddTheBookToTheCart

	| cart aBook |
	cart := Cart editorial: 'Tus Libros'.
	aBook := Book name: 'Librito' editorial: 'Tus Libros'.
	cart add: aBook.
	
	self assert: cart booksQuantity = 1.
	self assert: cart booksInCart = (Bag with: aBook)! !

!CartTest methodsFor: 'as yet unclassified' stamp: 'FedericoMendez 5/27/2013 21:39'!
test03CantAddABookToTheCartIfItDoesntBelongToTheEditorial

	| cart aBook |
	cart := Cart editorial: 'Tus Libros'.
	aBook := Book name: 'Librito' editorial: 'Libros de Pepe'.
	cart add: aBook.

	self assert: cart isEmpty.
! !

!CartTest methodsFor: 'as yet unclassified' stamp: 'FedericoMendez 5/27/2013 21:52'!
test04AddingABookTwiceShouldAddTheBookTwoTimesInTheCart

	| cart aBook bookList |
	cart := Cart editorial: 'Tus Libros'.
	aBook := Book name: 'Librito' editorial: 'Tus Libros'.
	cart add: aBook.
	cart add: aBook.

	self assert: cart booksQuantity = 2.
	self assert: (cart booksInCart occurrencesOf: aBook) = 2
! !
